; Page 0
; 6800 Disassembly from $FF00 to $FFFF
; 6800 Serial Monitor program for OSI 510 board
; compatible with Herb Johnson's 6800 cross assembler
;
; memory locations used by ROM
L1F34 EQU $1F34
L1F35 EQU $1F35
L1FB0 EQU $1FB0
L1FDF EQU $1FDF
ACIA  EQU $FC00
PIA   EQU $F700
;
	ORG	$FF00
;
;
LFF00
	JMP	INSER
	ASRA
	BCC	LFF00
;
LFF06
	LDAA	ACIA+1
	ANDA	#$7F
	CMPA	#$7F
	BEQ	LFF00
	JMP	OUTSER

LFF12
	BSR	LFF00
	CMPA	#$52  ;'R
	BEQ	LFF2B
	CMPA	#$30  ;'0
	BMI	LFF12
	CMPA	#$39  ;'9
	BLE	LFF2A
	CMPA	#$41  ;'A
	BMI	LFF12
	CMPA	#$46  ;'F
	BGT	LFF12
	SUBA	#$07
LFF2A	RTS

LFF2B	JMP	LFFA8

LFF2E
	BSR	LFF37
LFF30
	BSR	LFF45
	STAA	0, X
	INX
	BRA	LFF30

LFF37
	BSR	LFF45
	STAA	L1F34
	BSR	LFF45
	STAA	L1F35
	LDX	L1F34
	RTS

LFF45
	BSR	LFF12
	LSLA
	LSLA
	LSLA
	LSLA
	TAB
	BSR	LFF12
	ANDA	#$0F
	ABA
	RTS


	FCB	$00, $00

LFF54
	BSR	LFF37
LFF56
	LDAA	#$0D
	BSR	OUTSER
	LDAA	#$0A
	BSR	OUTSER
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	BSR	LFF77
	LDAA	ACIA
	ASRA
	BCC	LFF56
	JMP	LFFB2

LFF77
	BSR	LFF9F
	RTS

LFF7A
	LSRA
	LSRA
	LSRA
	LSRA
LFF7E
	ANDA	#$0F
	ADDA	#$30
	CMPA	#$39
	BLS	OUTSER
	ADDA	#$07
OUTSER
	PSHB
LFF89
	LDAB	ACIA
	ASRB
	ASRB
	BCC	LFF89
	STAA	ACIA+1
	PULB
	RTS

LFF95
	LDAA	0, X
	BSR	LFF7A
	LDAA	0, X
	BSR	LFF7E
	INX
	RTS

LFF9F
	BSR	LFF95
LFFA1
	LDAA	#$20
	BRA	OUTSER


	FCB	$00, $00, $00

LFFA8
	LDAA	#$03   ;IRQ, SWI vector entry
	STAA	ACIA   ;reset ACIA
	LDAA	#$B1
	STAA	ACIA   ;/16 8N2 +XIRQ +RIRQ
LFFB2
	LDS	#$1F28
	LDAA	#$0D
	BSR	OUTSER
	LDAA	#$0A
	BSR	OUTSER
	JSR	LFF00
	TAB
	BSR	LFFA1
	CMPB	#$4C  ;'L
	BNE	LFFCA
	JMP	LFF2E

LFFCA
	CMPB	#$50  ;'P
	BEQ	LFF54
	CMPB	#$47  ;'G
	BNE	LFFB2
	RTI

INSER
	LDAA	L1FDF ;$1FDF input redir flag?
	BEQ	LFFDB
	JMP	L1FB0

LFFDB
	LDAA	ACIA  ;Get char from serial
	ASRA
	BCC	LFFDB
	JMP	LFF06


	FCB	$00, $00, $00

LFFE7
	CLR	L1FDF	;reset vector entry
	LDAB	#$00
	STAB	PIA+1
	STAB	PIA  ;Set PIA DDRA to output
	LDAB	#$04
	STAB	PIA+1
	JMP	LFFA8
;
;				;IRQ vector ($FFA8)
;FFFA
	FCB  $FF, $A8  ;SWI instru, int vector ($FFA8)
;FFFC
	FCB  $1F, $E0  ;NMI vector   ($1FE0)
;FFFE
	FCB  $FF, $E7  ;reset vector	($FFE7)
;-----------------------------------------------------------------------------
	END